/**/

call RxFuncAdd 'SysIni', 'RexxUtil', 'SysIni'

SYSFILE='USER'
App='MGA32'
Value=''

Parse Arg all

displayusage=1

If words(all) = 0 then signal query
else cmd = translate(word(all,1))

displayusage=0

select
    when cmd = 'V' then call vsync
    when cmd = 'C' then call scursor
    when cmd = 'F' then call fonts
    when cmd = 'D' then call dive
    when cmd = 'G' then call grayscale
    otherwise signal usage
end

call SysIni SYSFILE, App, AppKey, Value

query:
say ''
call SysIni SYSFILE, App, 'All:', 'Keys'
if Result \= 'ERROR:' then
    do j=1 to Keys.0
        val = SysIni(SYSFILE, App, Keys.j)
        say left(Keys.j, 16) left(val, 20)
    end
else do
    say 'Using Default Configurations:'
    say left('WAITVSYNC', 16) left('ON', 20)
    say left('SOFTCURSOR', 16) left('ON', 20)
    end

if displayusage=0 then exit
say

usage:
say 'usage: mgaconf [v 0/1] / [c 0/1/2] / [f] / [d 0/1] / [g 0/1]'
say '   v 0  : don t wait for Vsync when change the palette'
say '   v 1  : wait for Vsync when change the palette (default, VP_3026 only)'
say '   c 0  : enable software cursor (default)'
say '   c 1  : disable software cursor'
say '   c 2  : disable software cursor if color count < 4 color'
say '   f    : modify the default system fonts, font resolution and AVIO fonts'
say '   d 0/1: switch OFF/ON DIVE for 24bpp in Warp'
say '   g 0/1: switch OFF/ON grayscale mode'
end:

exit


vsync:
AppKey='WAITVSYNC'
If words(all) > 1 then cmd2 = translate(word(all,2))
else do
    say 'for VSYNC ON  press 1'
    say 'for VSYNC OFF press 0'
    pull cmd2
end
select
    when cmd2 = '0' then Value='OFF'
    otherwise nop
end
return

scursor:
AppKey='SOFTCURSOR'
If words(all) > 1 then cmd2 = translate(word(all,2))
else do
    say 'for SOFTCURSOR ON                           press 0'
    say 'for SOFTCURSOR OFF                          press 1'
    say 'for SOFTCURSOR OFF if color count < 4 color press 2'
    pull cmd2
end
select
    when cmd2 = '1' then Value='OFF'
    when cmd2 = '2' then Value='4'
    otherwise nop
end
return

fonts:
If words(all) > 1 then cmd2 = translate(word(all,2))
else do
    say 'for Resolution  640x480  press 0'
    say 'for Resolution  800x600  press 1'
    say 'for Resolution 1024x768  press 2'
    say 'for Resolution 1152x882  press 3'
    say 'for Resolution 1280x1024 press 4'
    say 'for Resolution 1600x1200 press 5'
    say 'for Resolution 1600x1280 press 6'
    pull cmd2
end
select
    when cmd2 = '1' then RES='0800x0600'
    when cmd2 = '2' then RES='1024x0768'
    when cmd2 = '3' then RES='1152x0882'
    when cmd2 = '4' then RES='1280x1024'
    when cmd2 = '5' then RES='1600x1200'
    when cmd2 = '6' then RES='1600x1280'
    otherwise            RES='0640x0480'
end
If words(all) > 2 then cmd3 = translate(word(all,3))
else do
    say 'for Default System font  press 0'
    say 'for Font resolution      press 1'
    say 'for Avio font            press 2'
    pull cmd3
end
select
    when cmd3 = '0' then call SysFont
    when cmd3 = '1' then call ResFont
    otherwise            call VioFont
end
AppKey=RES'_'AltFont
return

SysFont:
AltFont='Sys'
If words(all) > 3 then cmd4 = translate(word(all,4))
else do
    say 'for Small  Font (100) press 0'
    say 'for Medium Font (101) press 1'
    say 'for Large  font (102) press 2'
    pull cmd4
end
select
    when cmd4 = '0' then Value='0100'
    when cmd4 = '1' then Value='0101'
    when cmd4 = '2' then Value='0102'
    otherwise nop
end
return

ResFont:
AltFont='Res'
If words(all) > 3 then cmd4 = translate(word(all,4))
else do
    say 'for 96  dpi  press 0'
    say 'for 100 dpi  press 1'
    pull cmd4
end
select
    when cmd4 = '0' then Value='0096'
    when cmd4 = '1' then Value='0100'
    otherwise nop
end
return

VioFont:
AltFont='Vio'
If words(all) > 3 then cmd4 = translate(word(all,4))
else do
    say 'for  8x8  press 0'
    say 'for 10x6  press 1'
    say 'for 10x8  press 2'
    say 'for 12x8  press 3'
    say 'for 14x6  press 4'
    say 'for 14x8  press 5'
    say 'for 15x7  press 6'
    say 'for 16x8  press 7'
    say 'for 16x12 press 8'
    say 'for 18x8  press 9'
    say 'for 18x10 press a'
    say 'for 20x12 press b'
    say 'for 22x12 press c'
    say 'for 25x7  press d'
    say 'for 30x12 press e'
    pull cmd4
end
select
    when cmd4 = '0' then Value='0808'
    when cmd4 = '1' then Value='1006'
    when cmd4 = '2' then Value='1008'
    when cmd4 = '3' then Value='1208'
    when cmd4 = '4' then Value='1406'
    when cmd4 = '5' then Value='1408'
    when cmd4 = '6' then Value='1507'
    when cmd4 = '7' then Value='1608'
    when cmd4 = '8' then Value='1612'
    when cmd4 = '9' then Value='1808'
    when cmd4 = 'A' then Value='1810'
    when cmd4 = 'B' then Value='2012'
    when cmd4 = 'C' then Value='2212'
    when cmd4 = 'D' then Value='2507'
    when cmd4 = 'E' then Value='3012'
    otherwise nop
end
return

dive:
AppKey='DIVE'
If words(all) > 1 then cmd2 = translate(word(all,2))
else do
    say 'for 24 bit per pel DIVE OFF press 0 (default)'
    say 'for 24 bit per pel DIVE ON  press 1'
    pull cmd2
end
select
    when cmd2 = '1' then Value='ON'
    otherwise nop
end
return

grayscale:
AppKey='GRAY_DRIVER'
If words(all) > 1 then cmd2 = translate(word(all,2))
else do
    say 'COLOR DRIVER press 0 (default)'
    say 'GRAY  DRIVER press 1'
    pull cmd2
end
select
    when cmd2 = '1' then Value='ON'
    otherwise nop
end
return
